package com.prolog.eis.service.out;


import com.prolog.eis.dto.outbound.ContainerTaskDismantleDto;
import com.prolog.eis.dto.page.AllotmentConfirm;
import com.prolog.eis.dto.page.AllotmentOrderDto;
import com.prolog.eis.model.container.ContainerTask;
import com.prolog.eis.model.out.ContainerTaskDismantle;
import com.prolog.framework.core.restriction.Criteria;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 出库任务拆零详情表-服务接口类
 * @date 2023-09-11 16:33
 */
public interface ContainerTaskDismantleService {

    /**
     * 新增数据
     *
     * @param containerTaskDismantle 出库任务拆零详情表
     */
    long save(ContainerTaskDismantle containerTaskDismantle);

    /**
     * 新增批量数据
     *
     * @param containerTaskDismantleList 出库任务拆零详情表
     */
    long saveBatch(List<ContainerTaskDismantle> containerTaskDismantleList);

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    List<ContainerTaskDismantle> findByMap(Map<String, Object> paramMap);

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    ContainerTaskDismantle findOneByMap(Map<String, Object> paramMap);

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    List<ContainerTaskDismantle> findByCriteria(Criteria criteria);

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ContainerTaskDismantle findById(int id);

    /**
     * 修改数据
     *
     * @param containerTaskDismantle 实例对象
     */
    long update(ContainerTaskDismantle containerTaskDismantle);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    long deleteById(int id);

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    long deleteByMap(Map<String, Object> paramMap);

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    long findCountByMap(Map<String, Object> paramMap);

    List<ContainerTask> findDismantlePickingList(String containerNo) throws Exception;

    ContainerTask findDismantlePickingDetail(String  containerSubNo) throws Exception;

    List<ContainerTask> dismantleFullList(String containerNo);

    List<ContainerTask> dismantleFullDetail(String containerNo);

    List<AllotmentOrderDto> findAllotmentOrder(String itemId);

    AllotmentOrderDto findAllotmentOrderDetail(AllotmentConfirm req);

    void updateMapByCriteria(Map<String, Object> map, Criteria criteria);

    List<ContainerTaskDismantleDto> findContainerTaskList(String warehouseArea);

    long findCountByCriteria(Criteria criteria);

    List<ContainerTaskDismantle>  findDismantleContainerTask(String containerSubNo);
}
